# Orion

Orion is a telegram bot that converts voice messages into text and org-mode files.
It can be trained for better accuracy.

## Requirements
You need to have Golang and Python installed.

## Usage
In order to use it, first you need to setup the project which you can just call
`./builder setup` . Also you need to store your bot's token (that you get from
Telegram's bot father) in the `.env` file like:

```
BOT_TOKEN=<ACTUAL_TOKEN_GOES_HERE>
```

and then you can run Orion via the builder script again with the
following command:

```bash
./builder run -owner TELEGRAM_ID -org-file ORG_FILE_PATH -model PATH_TO_MODEL -scorer PATH_TO_SCORER
```
* **TELEGRAM_ID**: Is your telegram id. It will only reply to you and tell others
to F off.

* **ORG_FILE_PATH**: Path to an `org-mode` file that **HAS TO EXIST**. Orion will append entries
to this file.
* **PATH_TO_MODEL(optoinal)**: Is the path to the model file you want to use for speech recognition.
the default points to the default model in the models directory.

* **PATH_TO_SCORER(optional)**: Is the path to the scorer to be use to speech recognition.
the default points to the default scorer in the models directory.

Models and scorers should be compatible with [Coqui](https://coqui.ai/).


## Rigel
**Orion** contains a text to speech server as well. Since I'm lazy I use Rigel to read stuff for
me. I integrated Rigel in my Emacs environment as well and it such a useful tool. For more info
on Rigel check out its [readme](https://devheroes.codes/lxsameer/Orion/src/branch/master/rigel/README.md)

Also if you want to integrate Rigel into your Emacs have a look at [the lib I created for it](https://devheroes.codes/FG42/FG42/src/branch/master/core/cubes/rigel/core.el)
for inspiration. Also you can use Rigel with anything it's not an Emacs only tool.
